//Si quelqu'un arrive  faire marcher a sur EZFA, pourrait-il me le dire s'il vous plat?

//J'utilise les #defines de <mygba.h>, flemme de les retaper ;)
#include <mygba.h>

//MULTIBOOT

//Fichiers graphiques, convertis avec GBA Graphics, de moi :p
#include "Res/Sol_nv1.map.c"
#include "Res/Sol_nv1.til.c"
#include "Res/Sol_nv1.pal.c"
#include "Res/Charset.til.c"
#include "Res/Mario.til.c"
#include "Res/Mario.pal.c"

//Dimensions de la map du niveau
#define TABLE_X 100
#define TABLE_Y 16

//Macros
#define ABS(x)	((x>0)?(x):(-x))
#define max(x,y)    ((x>y)?(x):(y))

//Variables globales
int gamma=0;

//Fichiers standard inclus
#include <stdio.h>

//Fichiers inclus
#include "materiel.h"
#include "routines.h"
#include "outils.h"
#include "Progs.h"
#include "Res/arriereplan_nv1.til.c"
#include "Res/arriereplan_nv1.map.c"

extern void test();

int main(void)          {
    int scrlX, scrlY, i, j;
    int intensite, direction;
    char str[4000];
	SPRITE mario;
	ECRAN Ecran;
	SPRITE sprites[SPRITE_LIMIT+2];
	int Pause=0, cptImages=0;

    memset(str,0,sizeof(str));
    REG_WSCNT=0x4317;
    gamma=0;
    // Passer en mode 0, avec le BG0 activ:
    REG_DISPCNT = (VIDEO_MODE0 | VIDEO_BG0_ENABLED | VIDEO_BG1_ENABLED | VIDEO_BG2_ENABLED | OBJ_ENABLED | 0x40);
    // Configure les diffrents plans
    REG_BG0CNT = BG_TEXTE_256x256 | BG_1_PALETTE | BG_WRAP | 31<<8 | 2;
    REG_BG1CNT = BG_TEXTE_256x256 | BG_1_PALETTE | BG_WRAP | 30<<8 | 1 | BG_CHARBLOCK_1;
    REG_BG2CNT = BG_TEXTE_256x256 | BG_1_PALETTE | BG_WRAP | 29<<8 | 3 | BG_CHARBLOCK_2;
    //Copie les palettes, 128 valeurs 16 bits
    CopieDMA((void*)sol_nv1_palette, (void*)Palette, 256>>1, DMA_16im);
    CopieDMA((void*)Mario_palette, (void*)PaletteObj, 256>>1, DMA_16im);
    // Les mosaques
    CopieDMA((void*)sol_nv1_tiles, (void*)CharBaseBlock(0), 4352>>1, DMA_16im);
    CopieDMA((void*)charset_tiles, (void*)CharBaseBlock(1), 14336>>1, DMA_16im);
    CopieDMA((void*)arriereplan_nv1_tiles, (void*)CharBaseBlock(2), 14336>>1, DMA_16im);
    //Celles des sprites
    CopieDMA((void*)Mario_tiles, (void*)0x06010000, 2048>>1, DMA_16im);
    // La carte : 1408 donnes  copier
    CopieDMA((void*)arriereplan_nv1_map,(void*)ScreenBaseBlock(29),1408>>1, DMA_16im);
    //Remplit la map texte (2) de vide
    memset((void*)ScreenBaseBlock(30),0,(256*256*2)/(8*8));

    //Vide l'OAM
    for (i=0;i<128;i++) {
        TOOL_OAM_OBJ_KILL(i);
        DetruitObjet(i);
    }
    //Et mon systme de sprites
    memset(sprites,0,sizeof(sprites));
    
    //Initialisation
    scrlX=0;
    scrlY=96;
    DessTexte(0,0,"SALUT TOUT LE MONDE!");
    DessTexte(0,18,"MERCI  LUDOVIC POUR SES");
    DessTexte(0,19,"COURS!");
    intensite=0;
    direction=1;

    //Cration de Mario
    CreeObjet(0,            //Numro d'objet
    0<<3,                   //Numro de mosaque (3), <<2 car 16x16 (*4) et <<1 car mode 8 bits (*2)
    10,                     //Position X initiale
    10,                     //Position Y initiale
    0,                      //Mode (alpha-blend)
    0,                      //Forme (0=carre)
    1,                      //Taille
    1,                      //Mode palette (1=256 couleurs, 0=16 couleurs)
    0,                      //Numro de palette si 16 couleurs
    1,                      //Priorit
    0,                      //Retournement vertical
    0,                      //Retournement horizontal
    0,                      //Mode mosaque (?)
    0,                      //Rotation
    0,                      //N de rotation
    0);                     //Double-taille (pour rotation)

	InitSprite(&mario,SPR_MARIO,16,80,16,16,1);						//Cre le premier sprite: Mario

    //Quelques Goombas
    CreeSprite(sprites,SPR_GOOMBA,80,80,-1);
    CreeSprite(sprites,SPR_GOOMBA,250,224,-1);
    CreeSprite(sprites,SPR_GOOMBA,400,80,-1);
    CreeSprite(sprites,SPR_GOOMBA,880,200,-1);
    CreeSprite(sprites,SPR_GOOMBA,1350,200,1);

    while(1)        {
        test(str);
        //Contraste/Luminosit
        if (REG_TOUCHES&TOUCHE_L && cptImages%4==0 && gamma>-31)     {
            CopieDMA((void*)sol_nv1_palette, (void*)Palette, 255, DMA_16im);
            CopieDMA((void*)Mario_palette, (void*)PaletteObj, 255, DMA_16im);
            GammaPalette(--gamma);
        }
        else if (REG_TOUCHES&TOUCHE_R && cptImages%4==0 && gamma<31)        {
            CopieDMA((void*)sol_nv1_palette, (void*)Palette, 255, DMA_16im);
            CopieDMA((void*)Mario_palette, (void*)PaletteObj, 255, DMA_16im);
            GammaPalette(++gamma);
        }
        //Pause
        if (REG_TOUCHES&TOUCHE_START)       {
            if (!interdit.ft.start)     {
                interdit.ft.start=1;
                Pause=!Pause;
            }
        }
        else
            interdit.ft.start=0;
        //Select
        if (REG_TOUCHES&TOUCHE_SELECT)      {
            if (!interdit.ft.select || REG_TOUCHES&TOUCHE_A)     {
                interdit.ft.select=1;
//				CreeSprite(sprites,SPR_FAIT_RIEN,mario.x,mario.y,0);
				CreeSprite(sprites,SPR_GOOMBA,mario.x+100,80,-1);
            }
        }
        else
            interdit.ft.select=0;

        //Bloc clignotant
        if (intensite>=31)
            direction=-1;
        if (intensite<=0)
            direction=1;
        intensite+=direction;
        Palette[14]=Rvb(intensite/2,0,0);
        Palette[17]=Rvb(16+intensite/2,intensite/2,0);
        Palette[16]=Rvb(16+intensite/2,16+intensite/2,0);
        
        if (!Pause)     {
            Ecran.scrlX=scrlX;
            Ecran.scrlY=scrlY;
            GereTouches(&mario);
    		for (i=0;i<=max(ABS(mario.vitesse),ABS(mario.gravite));i++)	{
    			DetecteCollisions(NULL,&Ecran,&mario);
    			BougeSprite(&mario,i);
    		}
    		GereScrolling(&mario,&scrlX,&scrlY);
            AfficheMario(&mario,scrlX,scrlY);
            sprintf(str,"POS: %i,%i  ",mario.x,mario.y);
            DessTexte(0,1,str);
        }
        else    {
            DessTexte(0,1,"JEU EN PAUSE  ");
        }
        j=0;
        for (i=0;i<SPRITE_LIMIT;i++)
            if (sprites[i].type)
                j++;
        sprintf(str,"OBJ: %i  ",j);
        DessTexte(0,2,str);

        CopieMap_16((unsigned short*)sol_nv1_map,
            divisionEntiere(scrlX,16),divisionEntiere(scrlY,16),
            16,11,
            100,16,
            32);

        if (!Pause)     {
            Ecran.scrlX=scrlX;
            Ecran.scrlY=scrlY;
    		GereSprites(NULL,sprites,&mario,&Ecran);					//Gre et affiche les sprites...
        }		
        
		if (mario.type==0)
    		break;
		
		//Incrmentation du compteur d'images
        cptImages++;
        i=*CompteurScanline;
        if (i>160)
            j=i-160;
        else
            j=i+70;
        sprintf(str,"CPU: %02i%%  ",(int)(100*j)/230);
        DessTexte(0,3,str);
        //Attendre un peu avant la prochaine action
        AttendVSync();
        // Dfinir le dcalage (quelle partie de la carte afficher ?)
        REG_BG0VOFS = modulo(scrlY,16);
        REG_BG0HOFS = modulo(scrlX,16);
        REG_BG2VOFS = scrlY/8;
        REG_BG2HOFS = scrlX/4;
        CopieDMA((void*)tableau,(void*)ScreenBaseBlock(31),(32*22)>>1,DMA_32im);
        CopieDMA(MonOAM,pOAM,1024>>2,DMA_32im);
    }
    //Fade sur le noir (jeu termin ou quitt)
    for (i=0;i<31;i++)      {
        GammaPalette(-1);
        for (j=0;j<1;j++)
            AttendVSync();
    }
    return 0;
}

/*int main(void)      {
    int i,j,k;
    ham_Init();
    ham_InitText(0);
    k=32;
    Palette[0]=RGB(0,0,31);
    for (j=0;j<14;j++)      {
        for (i=0;i<30;i++)      {
            ham_DrawText(i,j,"%c",k++);
        }
    }
    while(1);
    return 0;
}*/

/* END OF FILE */
